import { OptionList } from '../util/Options.js';
import { MathDocument } from './MathDocument.js';
import { MathItem } from './MathItem.js';
import { DOMAdaptor } from '../core/DOMAdaptor.js';
export interface OutputJax<N, T, D> {
    name: string;
    options: OptionList;
    adaptor: DOMAdaptor<N, T, D>;
    setAdaptor(adaptor: DOMAdaptor<N, T, D>): void;
    typeset(math: MathItem<N, T, D>, document?: MathDocument<N, T, D>): N;
    escaped(math: MathItem<N, T, D>, document?: MathDocument<N, T, D>): N;
    getMetrics(document: MathDocument<N, T, D>): void;
    styleSheet(document: MathDocument<N, T, D>): N;
}
export declare abstract class AbstractOutputJax<N, T, D> implements OutputJax<N, T, D> {
    static NAME: string;
    static OPTIONS: OptionList;
    options: OptionList;
    adaptor: DOMAdaptor<N, T, D>;
    constructor(options?: OptionList);
    readonly name: string;
    setAdaptor(adaptor: DOMAdaptor<N, T, D>): void;
    abstract typeset(math: MathItem<N, T, D>, document?: MathDocument<N, T, D>): N;
    abstract escaped(math: MathItem<N, T, D>, document?: MathDocument<N, T, D>): N;
    getMetrics(document: MathDocument<N, T, D>): void;
    styleSheet(document: MathDocument<N, T, D>): N;
}
