import { AbstractInputJax } from '../core/InputJax.js';
import { OptionList } from '../util/Options.js';
import { MathItem } from '../core/MathItem.js';
import { MmlNode } from '../core/MmlTree/MmlNode.js';
import { FindTeX } from './tex/FindTeX.js';
export declare class TeX<N, T, D> extends AbstractInputJax<N, T, D> {
    static NAME: string;
    static OPTIONS: OptionList;
    protected findTeX: FindTeX<N, T, D>;
    constructor(options: OptionList);
    compile(math: MathItem<N, T, D>): MmlNode;
    findMath(strings: string[]): {
        math: string;
        start: {
            i?: number;
            n?: number;
            delim?: string;
            node?: N | T;
        };
        end: {
            i?: number;
            n?: number;
            delim?: string;
            node?: N | T;
        };
        open?: string;
        close?: string;
        n?: number;
        display: boolean;
    }[];
}
