import * as sm from './SymbolMap.js';
import { HandlerType, Configuration, ParseInput, ParseResult, ParseMethod } from './Types.js';
import { MmlNode } from '../../core/MmlTree/MmlNode.js';
import { MmlMo } from '../../core/MmlTree/MmlNodes/mo.js';
import { StackItem, EnvList } from './StackItem.js';
import Stack from './Stack.js';
import { Symbol } from './Symbol.js';
export default class TexParser {
    macroCount: number;
    secondPass: MmlMo[];
    private input;
    private remainder;
    private configurations;
    NBSP: string;
    string: string;
    i: number;
    remap: sm.CharacterMap;
    stack: Stack;
    constructor(str: string, env: EnvList);
    process(tex: string): void;
    setup(env: Record<string, ParseMethod>): void;
    configure(config: Configuration): void;
    append(config: Configuration): void;
    parse(kind: HandlerType, input: ParseInput): ParseResult;
    lookup(kind: HandlerType, symbol: string): {};
    fallback(kind: HandlerType, method: ParseMethod): void;
    contains(kind: HandlerType, symbol: string): boolean;
    toString(): string;
    Parse(): void;
    Push(arg: StackItem | MmlNode): void;
    PushAll(args: (StackItem | MmlNode)[]): void;
    mml(): MmlNode;
    mmlToken(token: MmlNode): MmlNode;
    convertDelimiter(c: string): string;
    trimSpaces(text: string): string;
    nextIsSpace(): RegExpMatchArray;
    GetNext(): string;
    GetCS(name?: string): string;
    GetArgument(name: string, noneOK?: boolean): string;
    GetBrackets(name: string, def?: string): string;
    GetDelimiter(name: string, braceOK?: boolean): string;
    GetDimen(name: string): string;
    GetUpTo(name: string, token: string): string;
    ParseArg(name: string): MmlNode;
    ParseUpTo(name: string, token: string): MmlNode;
    InternalMath(text: string, level?: number | string): MmlNode[];
    InternalText(text: string, def: EnvList): MmlNode;
    GetDelimiterArg(name: string): string;
    GetStar(): boolean;
    GetRemap(char: string): Symbol;
}
