import { AbstractOutputJax } from '../core/OutputJax.js';
import { OptionList } from '../util/Options.js';
import { MathDocument } from '../core/MathDocument.js';
import { MathItem } from '../core/MathItem.js';
import { MmlNode } from '../core/MmlTree/MmlNode.js';
import { CHTMLWrapper } from './chtml/Wrapper.js';
import { CHTMLWrapperFactory } from './chtml/WrapperFactory.js';
import { FontData } from './chtml/FontData.js';
import { CssStyles } from './chtml/CssStyles.js';
import { BBox } from './chtml/BBox.js';
export declare class CHTML<N, T, D> extends AbstractOutputJax<N, T, D> {
    static NAME: string;
    static OPTIONS: OptionList;
    factory: CHTMLWrapperFactory<N, T, D>;
    font: FontData;
    cssStyles: CssStyles;
    document: MathDocument<N, T, D>;
    math: MathItem<N, T, D>;
    nodeMap: Map<MmlNode, CHTMLWrapper<N, T, D>>;
    constructor(options?: OptionList);
    typeset(math: MathItem<N, T, D>, html: MathDocument<N, T, D>): N;
    getBBox(math: MathItem<N, T, D>, html: MathDocument<N, T, D>): BBox;
    escaped(math: MathItem<N, T, D>, html: MathDocument<N, T, D>): N;
    getMetrics(html: MathDocument<N, T, D>): void;
    styleSheet(html: MathDocument<N, T, D>): N;
    toCHTML(node: MmlNode, parent: N): void;
    html(type: string, def?: OptionList, content?: (N | T)[]): N;
    text(text: string): T;
}
