"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var mfenced_js_1 = require("../../../core/MmlTree/MmlNodes/mfenced.js");
var CHTMLmfenced = (function (_super) {
    __extends(CHTMLmfenced, _super);
    function CHTMLmfenced(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        _this.mrow = null;
        _this.createMrow();
        _this.addMrowChildren();
        return _this;
    }
    CHTMLmfenced.prototype.createMrow = function () {
        var mmlFactory = this.node.factory;
        var mrow = mmlFactory.create('inferredMrow');
        var attributes = this.node.attributes;
        var display = attributes.get('display');
        var scriptlevel = attributes.get('scriptlevel');
        var defaults = {
            mathsize: ['math', attributes.get('mathsize')]
        };
        mrow.setInheritedAttributes(defaults, display, scriptlevel, false);
        this.mrow = this.wrap(mrow);
        this.mrow.parent = this;
    };
    CHTMLmfenced.prototype.addMrowChildren = function () {
        var mfenced = this.node;
        var mrow = this.mrow;
        this.addMo(mfenced.open);
        if (this.childNodes.length) {
            mrow.childNodes.push(this.childNodes[0]);
        }
        var i = 0;
        try {
            for (var _a = __values(this.childNodes.slice(1)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var child = _b.value;
                this.addMo(mfenced.separators[i++]);
                mrow.childNodes.push(child);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.addMo(mfenced.close);
        mrow.stretchChildren();
        var e_1, _c;
    };
    CHTMLmfenced.prototype.addMo = function (node) {
        if (!node)
            return;
        var mo = this.wrap(node);
        this.mrow.childNodes.push(mo);
        mo.parent = this.mrow;
    };
    CHTMLmfenced.prototype.toCHTML = function (parent) {
        var chtml = this.standardCHTMLnode(parent);
        this.mrow.toCHTML(chtml);
        this.drawBBox();
    };
    CHTMLmfenced.prototype.computeBBox = function (bbox) {
        bbox.updateFrom(this.mrow.getBBox());
    };
    return CHTMLmfenced;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmfenced.kind = mfenced_js_1.MmlMfenced.prototype.kind;
exports.CHTMLmfenced = CHTMLmfenced;
//# sourceMappingURL=mfenced.js.map