import { CHTMLWrapper } from '../Wrapper.js';
import { CHTMLWrapperFactory } from '../WrapperFactory.js';
import { CHTMLmo } from './mo.js';
import { MmlNode } from '../../../core/MmlTree/MmlNode.js';
import { BBox } from '../BBox.js';
import { StyleList } from '../CssStyles.js';
import { DIRECTION } from '../FontData.js';
export declare class CHTMLmfrac<N, T, D> extends CHTMLWrapper<N, T, D> {
    static kind: string;
    static styles: StyleList;
    protected bevel: CHTMLmo<N, T, D>;
    constructor(factory: CHTMLWrapperFactory<N, T, D>, node: MmlNode, parent?: CHTMLWrapper<N, T, D>);
    toCHTML(parent: N): void;
    computeBBox(bbox: BBox): void;
    protected makeFraction(display: boolean, t: number): void;
    protected getFractionBBox(bbox: BBox, display: boolean, t: number): void;
    protected makeAtop(display: boolean): void;
    protected getAtopBBox(bbox: BBox, display: boolean): void;
    protected getUVQ(display: boolean): {
        u: number;
        v: number;
        q: number;
        nbox: BBox;
        dbox: BBox;
    };
    protected makeBevelled(display: boolean): void;
    protected getBevelledBBox(bbox: BBox, display: boolean): void;
    protected getBevelData(display: boolean): {
        H: number;
        delta: number;
        u: number;
        v: number;
        nbox: BBox;
        dbox: BBox;
    };
    canStretch(direction: DIRECTION): boolean;
    protected isDisplay(): boolean;
}
