"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var mfrac_js_1 = require("../../../core/MmlTree/MmlNodes/mfrac.js");
var CHTMLmfrac = (function (_super) {
    __extends(CHTMLmfrac, _super);
    function CHTMLmfrac(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        _this.bevel = null;
        if (_this.node.attributes.get('bevelled')) {
            var H = _this.getBevelData(_this.isDisplay()).H;
            var bevel = _this.bevel = _this.createMo('/');
            bevel.canStretch(1);
            bevel.getStretchedVariant([H], true);
        }
        return _this;
    }
    CHTMLmfrac.prototype.toCHTML = function (parent) {
        this.standardCHTMLnode(parent);
        var _a = this.node.attributes.getList('linethickness', 'bevelled'), linethickness = _a.linethickness, bevelled = _a.bevelled;
        var display = this.isDisplay();
        if (bevelled) {
            this.makeBevelled(display);
        }
        else {
            var thickness = this.length2em(String(linethickness));
            if (thickness === 0) {
                this.makeAtop(display);
            }
            else {
                this.makeFraction(display, thickness);
            }
        }
    };
    CHTMLmfrac.prototype.computeBBox = function (bbox) {
        bbox.empty();
        var _a = this.node.attributes.getList('linethickness', 'bevelled'), linethickness = _a.linethickness, bevelled = _a.bevelled;
        var display = this.isDisplay();
        if (bevelled) {
            this.getBevelledBBox(bbox, display);
        }
        else {
            var thickness = this.length2em(String(linethickness));
            if (thickness === 0) {
                this.getAtopBBox(bbox, display);
            }
            else {
                this.getFractionBBox(bbox, display, thickness);
            }
        }
        bbox.clean();
    };
    CHTMLmfrac.prototype.makeFraction = function (display, t) {
        var _a = this.node.attributes.getList('numalign', 'denomalign'), numalign = _a.numalign, denomalign = _a.denomalign;
        var withDelims = this.node.getProperty('withDelims');
        var attr = (display ? { type: 'd' } : {});
        var fattr = (withDelims ? __assign({}, attr, { delims: 'true' }) : __assign({}, attr));
        var nattr = (numalign !== 'center' ? { align: numalign } : {});
        var dattr = (denomalign !== 'center' ? { align: denomalign } : {});
        var dsattr = __assign({}, attr), nsattr = __assign({}, attr);
        var fparam = this.font.params;
        if (t !== .06) {
            var a = fparam.axis_height;
            var tEm = this.em(t), T = (display ? 3.5 : 1.5) * t;
            var m = (display ? this.em(3 * t) : tEm) + ' -.1em';
            attr.style = { height: tEm, 'border-top': tEm + ' solid', margin: m };
            var nh = this.em(Math.max(0, (display ? fparam.num1 : fparam.num2) - a - T));
            nsattr.style = { height: nh, 'vertical-align': '-' + nh };
            dsattr.style = { height: this.em(Math.max(0, (display ? fparam.denom1 : fparam.denom2) + a - T)) };
            fattr.style = { 'vertical-align': this.em(a - T) };
        }
        var num, den;
        this.adaptor.append(this.chtml, this.html('mjx-frac', fattr, [
            num = this.html('mjx-num', nattr, [this.html('mjx-nstrut', nsattr)]),
            this.html('mjx-dbox', {}, [
                this.html('mjx-dtable', {}, [
                    this.html('mjx-line', attr),
                    this.html('mjx-row', {}, [
                        den = this.html('mjx-den', dattr, [this.html('mjx-dstrut', dsattr)])
                    ])
                ])
            ])
        ]));
        this.childNodes[0].toCHTML(num);
        this.childNodes[1].toCHTML(den);
    };
    CHTMLmfrac.prototype.getFractionBBox = function (bbox, display, t) {
        var nbox = this.childNodes[0].getBBox();
        var dbox = this.childNodes[1].getBBox();
        var fparam = this.font.params;
        var pad = (this.node.getProperty('withDelims') ? 0 : fparam.nulldelimiterspace);
        var a = fparam.axis_height;
        var T = (display ? 3.5 : 1.5) * t;
        bbox.combine(nbox, 0, a + T + Math.max(nbox.d * nbox.rscale, (display ? fparam.num1 : fparam.num2) - a - T));
        bbox.combine(dbox, 0, a - T - Math.max(dbox.h * dbox.rscale, (display ? fparam.denom1 : fparam.denom2) + a - T));
        bbox.w += 2 * pad + .2;
    };
    CHTMLmfrac.prototype.makeAtop = function (display) {
        var _a = this.node.attributes.getList('numalign', 'denomalign'), numalign = _a.numalign, denomalign = _a.denomalign;
        var withDelims = this.node.getProperty('withDelims');
        var attr = (display ? { type: 'd', atop: true } : { atop: true });
        var fattr = (withDelims ? __assign({}, attr, { delims: true }) : __assign({}, attr));
        var nattr = (numalign !== 'center' ? { align: numalign } : {});
        var dattr = (denomalign !== 'center' ? { align: denomalign } : {});
        var _b = this.getUVQ(display), v = _b.v, q = _b.q;
        nattr.style = { 'padding-bottom': this.em(q) };
        fattr.style = { 'vertical-align': this.em(-v) };
        var num, den;
        this.adaptor.append(this.chtml, this.html('mjx-frac', fattr, [
            num = this.html('mjx-num', nattr),
            den = this.html('mjx-den', dattr)
        ]));
        this.childNodes[0].toCHTML(num);
        this.childNodes[1].toCHTML(den);
    };
    CHTMLmfrac.prototype.getAtopBBox = function (bbox, display) {
        var fparam = this.font.params;
        var pad = (this.node.getProperty('withDelims') ? 0 : fparam.nulldelimiterspace);
        var _a = this.getUVQ(display), u = _a.u, v = _a.v, nbox = _a.nbox, dbox = _a.dbox;
        bbox.combine(nbox, 0, u);
        bbox.combine(dbox, 0, -v);
        bbox.w += 2 * pad;
    };
    CHTMLmfrac.prototype.getUVQ = function (display) {
        var nbox = this.childNodes[0].getBBox();
        var dbox = this.childNodes[1].getBBox();
        var fparam = this.font.params;
        var _a = __read((display ? [fparam.num1, fparam.denom1] : [fparam.num3, fparam.denom2]), 2), u = _a[0], v = _a[1];
        var p = (display ? 7 : 3) * fparam.rule_thickness;
        var q = (u - nbox.d * nbox.scale) - (dbox.h * dbox.scale - v);
        if (q < p) {
            u += (p - q) / 2;
            v += (p - q) / 2;
            q = p;
        }
        return { u: u, v: v, q: q, nbox: nbox, dbox: dbox };
    };
    CHTMLmfrac.prototype.makeBevelled = function (display) {
        var adaptor = this.adaptor;
        this.childNodes[0].toCHTML(this.chtml);
        this.bevel.toCHTML(this.chtml);
        this.childNodes[1].toCHTML(this.chtml);
        var _a = this.getBevelData(display), u = _a.u, v = _a.v, delta = _a.delta, nbox = _a.nbox, dbox = _a.dbox;
        if (u) {
            var num = this.childNodes[0].chtml;
            adaptor.setStyle(num, 'verticalAlign', this.em(u / nbox.scale));
        }
        if (v) {
            var denom = this.childNodes[1].chtml;
            adaptor.setStyle(denom, 'verticalAlign', this.em(v / dbox.scale));
        }
        var dx = this.em(-delta / 2);
        adaptor.setStyle(this.bevel.chtml, 'marginLeft', dx);
        adaptor.setStyle(this.bevel.chtml, 'marginRight', dx);
    };
    CHTMLmfrac.prototype.getBevelledBBox = function (bbox, display) {
        var _a = this.getBevelData(display), u = _a.u, v = _a.v, delta = _a.delta, nbox = _a.nbox, dbox = _a.dbox;
        var lbox = this.bevel.getBBox();
        bbox.combine(nbox, 0, u);
        bbox.combine(lbox, bbox.w - delta / 2, 0);
        bbox.combine(dbox, bbox.w - delta / 2, v);
    };
    CHTMLmfrac.prototype.getBevelData = function (display) {
        var nbox = this.childNodes[0].getBBox();
        var dbox = this.childNodes[1].getBBox();
        var delta = (display ? .4 : .15);
        var H = Math.max(nbox.scale * (nbox.h + nbox.d), dbox.scale * (dbox.h + dbox.d)) + 2 * delta;
        var a = this.font.params.axis_height;
        var u = nbox.scale * (nbox.d - nbox.h) / 2 + a + delta;
        var v = dbox.scale * (dbox.d - dbox.h) / 2 + a - delta;
        return { H: H, delta: delta, u: u, v: v, nbox: nbox, dbox: dbox };
    };
    CHTMLmfrac.prototype.canStretch = function (direction) {
        return false;
    };
    CHTMLmfrac.prototype.isDisplay = function () {
        var _a = this.node.attributes.getList('displaystyle', 'scriptlevel'), displaystyle = _a.displaystyle, scriptlevel = _a.scriptlevel;
        return displaystyle && scriptlevel === 0;
    };
    return CHTMLmfrac;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmfrac.kind = mfrac_js_1.MmlMfrac.prototype.kind;
CHTMLmfrac.styles = {
    'mjx-frac': {
        display: 'inline-block',
        'vertical-align': '0.17em',
        padding: '0 .22em'
    },
    'mjx-frac[type="d"]': {
        'vertical-align': '.04em'
    },
    'mjx-frac[delims]': {
        padding: '0 .1em'
    },
    'mjx-frac[atop]': {
        padding: '0 .12em'
    },
    'mjx-frac[atop][delims]': {
        padding: '0'
    },
    'mjx-dtable': {
        display: 'inline-table',
        width: '100%'
    },
    'mjx-dtable > *': {
        'font-size': '2000%'
    },
    'mjx-dbox': {
        display: 'block',
        'font-size': '5%'
    },
    'mjx-row': {
        display: 'table-row'
    },
    'mjx-num': {
        display: 'block',
        'text-align': 'center'
    },
    'mjx-den': {
        display: 'block',
        'text-align': 'center'
    },
    'mjx-den[align="right"], mjx-num[align="right"]': {
        'text-align': 'right'
    },
    'mjx-den[align="left"], mjx-num[align="left"]': {
        'text-align': 'left'
    },
    'mjx-nstrut': {
        display: 'inline-block',
        height: '.054em',
        width: 0,
        'vertical-align': '-.054em'
    },
    'mjx-nstrut[type="d"]': {
        height: '.217em',
        'vertical-align': '-.217em',
    },
    'mjx-dstrut': {
        display: 'inline-block',
        height: '.505em',
        width: 0
    },
    'mjx-dstrut[type="d"]': {
        height: '.726em',
    },
    'mjx-line': {
        display: 'block',
        'box-sizing': 'border-box',
        'min-height': '1px',
        height: '.06em',
        'border-top': '.06em solid',
        margin: '.06em -.1em',
        overflow: 'hidden'
    },
    'mjx-line[type="d"]': {
        margin: '.18em -.1em'
    }
};
exports.CHTMLmfrac = CHTMLmfrac;
//# sourceMappingURL=mfrac.js.map