import { CHTMLWrapper } from '../Wrapper.js';
import { CHTMLWrapperFactory } from '../WrapperFactory.js';
import { BBox } from '../BBox.js';
import { MmlNode } from '../../../core/MmlTree/MmlNode.js';
import { StyleList } from '../CssStyles.js';
export declare type TableData = {
    H: number[];
    D: number[];
    W: number[];
    NH: number[];
    ND: number[];
    L: number;
};
export declare class CHTMLmtable<N, T, D> extends CHTMLWrapper<N, T, D> {
    static kind: string;
    static styles: StyleList;
    labels: N;
    protected numCols: number;
    protected numRows: number;
    protected frame: boolean;
    protected fSpace: number[];
    protected cSpace: number[];
    protected rSpace: number[];
    protected cLines: number[];
    protected rLines: number[];
    protected cWidths: (number | string)[];
    protected data: TableData;
    constructor(factory: CHTMLWrapperFactory<N, T, D>, node: MmlNode, parent?: CHTMLWrapper<N, T, D>);
    protected stretchRows(): void;
    protected stretchColumns(): void;
    protected stretchColumn(i: number, W: number): void;
    toCHTML(parent: N): void;
    getTableData(): TableData;
    protected updateHDW(cell: CHTMLWrapper<N, T, D>, i: number, j: number, H: number[], D: number[], W?: number[]): void;
    computeBBox(bbox: BBox): void;
    protected getBBoxHD(height: number): number[];
    protected padRows(): void;
    protected handleColumnSpacing(): void;
    protected handleColumnLines(): void;
    protected handleColumnWidths(): void;
    protected handleRowSpacing(): void;
    protected handleRowLines(): void;
    protected handleEqualRows(): void;
    protected setRowHeight(row: CHTMLWrapper<N, T, D>, HD: number, D: number, space: number): void;
    protected handleFrame(): void;
    protected handleWidth(): void;
    protected handleAlign(): void;
    protected handleLabels(): void;
    protected updateRowHeights(): void;
    protected addLabelSpacing(): void;
    protected getEqualRowHeight(): any;
    protected getColumnWidths(): any[];
    protected getEqualColumns(width: string): any[];
    protected getColumnWidthsAuto(swidths: string[]): (string | number)[];
    protected getColumnWidthsPercent(swidths: string[], width: string): (string | number)[];
    protected getColumnWidthsFixed(swidths: string[], width: number): number[];
    protected getVerticalPosition(i: number, align: string): number;
    protected getAlignmentRow(): [string, number];
    protected getColumnAttributes(name: string, i?: number): string[];
    protected getRowAttributes(name: string, i?: number): string[];
    protected getAttributeArray(name: string): string[];
    protected addEm(list: number[], n?: number): string[];
    protected convertLengths(list: string[]): number[];
}
