"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Wrapper_js_1 = require("../Wrapper.js");
var mtable_js_1 = require("../../../core/MmlTree/MmlNodes/mtable.js");
function SUM(A) {
    return A.reduce(function (a, b) { return a + b; }, 0);
}
function MAX(A) {
    return A.reduce(function (a, b) { return Math.max(a, b); }, 0);
}
function isPercent(x) {
    return x.match(/%\s*$/);
}
function SPLIT(x) {
    return x.trim().split(/\s+/);
}
var CHTMLmtable = (function (_super) {
    __extends(CHTMLmtable, _super);
    function CHTMLmtable(factory, node, parent) {
        if (parent === void 0) { parent = null; }
        var _this = _super.call(this, factory, node, parent) || this;
        _this.numCols = 0;
        _this.numRows = 0;
        _this.data = null;
        _this.labels = _this.html('mjx-labels', { align: node.attributes.get('side') });
        _this.numCols = MAX(_this.childNodes.map(function (row) { return row.numCells; }));
        _this.numRows = _this.childNodes.length;
        var attributes = node.attributes;
        _this.frame = attributes.get('frame') !== 'none';
        _this.fSpace = (_this.frame ? _this.convertLengths(_this.getAttributeArray('framespacing')) : [0, 0]);
        _this.cSpace = _this.convertLengths(_this.getColumnAttributes('columnspacing'));
        _this.rSpace = _this.convertLengths(_this.getRowAttributes('rowspacing'));
        _this.cLines = _this.getColumnAttributes('columnlines').map(function (x) { return (x === 'none' ? 0 : .07); });
        _this.rLines = _this.getRowAttributes('rowlines').map(function (x) { return (x === 'none' ? 0 : .07); });
        _this.cWidths = _this.getColumnWidths();
        _this.stretchRows();
        _this.stretchColumns();
        return _this;
    }
    CHTMLmtable.prototype.stretchRows = function () {
        var equal = this.node.attributes.get('equalrows');
        var HD = (equal ? this.getEqualRowHeight() : 0);
        var _a = (equal ? this.getTableData() : { H: [0], D: [0] }), H = _a.H, D = _a.D;
        for (var i = 0; i < this.numRows; i++) {
            var hd = (equal ? [(HD + H[i] - D[i]) / 2, (HD - H[i] + D[i]) / 2] : null);
            this.childNodes[i].stretchChildren(hd);
        }
    };
    CHTMLmtable.prototype.stretchColumns = function () {
        for (var i = 0; i < this.numCols; i++) {
            var width = (typeof this.cWidths[i] === 'number' ? this.cWidths[i] : null);
            this.stretchColumn(i, width);
        }
    };
    CHTMLmtable.prototype.stretchColumn = function (i, W) {
        var stretchy = [];
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var cell = row.childNodes[i + row.firstCell];
                if (cell) {
                    var child = cell.childNodes[0];
                    if (child.stretch.dir === 0 &&
                        child.canStretch(2)) {
                        stretchy.push(child);
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var count = stretchy.length;
        var nodeCount = this.childNodes.length;
        if (count && nodeCount > 1) {
            if (W === null) {
                W = 0;
                var all = (count > 1 && count === nodeCount);
                try {
                    for (var _d = __values(this.childNodes), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var row = _e.value;
                        var cell = row.childNodes[i + row.firstCell];
                        if (cell) {
                            var child = cell.childNodes[0];
                            var noStretch = (child.stretch.dir === 0);
                            if (all || noStretch) {
                                var w = child.getBBox(noStretch).w;
                                if (w > W) {
                                    W = w;
                                }
                            }
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            try {
                for (var stretchy_1 = __values(stretchy), stretchy_1_1 = stretchy_1.next(); !stretchy_1_1.done; stretchy_1_1 = stretchy_1.next()) {
                    var child = stretchy_1_1.value;
                    child.coreMO().getStretchedVariant([W]);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (stretchy_1_1 && !stretchy_1_1.done && (_g = stretchy_1.return)) _g.call(stretchy_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
        }
        var e_1, _c, e_2, _f, e_3, _g;
    };
    CHTMLmtable.prototype.toCHTML = function (parent) {
        var chtml = this.standardCHTMLnode(parent);
        var table = this.adaptor.append(chtml, this.html('mjx-itable'));
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var child = _b.value;
                child.toCHTML(table);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_4) throw e_4.error; }
        }
        this.padRows();
        this.handleColumnSpacing();
        this.handleColumnLines();
        this.handleColumnWidths();
        this.handleRowSpacing();
        this.handleRowLines();
        this.handleEqualRows();
        this.handleFrame();
        this.handleWidth();
        this.handleLabels();
        this.handleAlign();
        var e_4, _c;
    };
    CHTMLmtable.prototype.getTableData = function () {
        if (this.data) {
            return this.data;
        }
        var H = new Array(this.numRows).fill(0);
        var D = new Array(this.numRows).fill(0);
        var W = new Array(this.numCols).fill(0);
        var NH = new Array(this.numRows);
        var ND = new Array(this.numRows);
        var LW = [0];
        for (var j = 0; j < this.numRows; j++) {
            var row = this.childNodes[j];
            var cellCount = row.numCells;
            var firstCell = row.firstCell;
            for (var i = 0; i < cellCount; i++) {
                this.updateHDW(row.childNodes[i + firstCell], i, j, H, D, W);
            }
            NH[j] = H[j];
            ND[j] = D[j];
            if (firstCell > 0) {
                this.updateHDW(row.childNodes[0], 0, j, H, D, LW);
            }
        }
        var w = this.node.attributes.get('width');
        var L = LW[0];
        this.data = { H: H, D: D, W: W, NH: NH, ND: ND, L: L };
        return this.data;
    };
    CHTMLmtable.prototype.updateHDW = function (cell, i, j, H, D, W) {
        if (W === void 0) { W = null; }
        var _a = cell.getBBox(), h = _a.h, d = _a.d, w = _a.w;
        if (h < .75)
            h = .75;
        if (d < .25)
            d = .25;
        if (h > H[j])
            H[j] = h;
        if (d > D[j])
            D[j] = d;
        if (W && w > W[i])
            W[i] = w;
    };
    CHTMLmtable.prototype.computeBBox = function (bbox) {
        var _this = this;
        var _a = this.getTableData(), H = _a.H, D = _a.D, W = _a.W;
        var height, width;
        if (this.node.attributes.get('equalrows')) {
            var HD = this.getEqualRowHeight();
            height = SUM([].concat(this.rLines, this.rSpace)) + HD * this.numRows;
        }
        else {
            height = SUM(H.concat(D, this.rLines, this.rSpace));
        }
        height += (this.frame ? .14 + 2 * this.fSpace[1] : 0);
        var CW = Array.from(W.keys()).map(function (i) {
            return (typeof _this.cWidths[i] === 'number' ? _this.cWidths[i] : W[i]);
        });
        width = SUM(CW.concat(this.cLines, this.cSpace)) + (this.frame ? .14 + 2 * this.fSpace[0] : 0);
        var w = this.node.attributes.get('width');
        if (w !== 'auto') {
            var cwidth = this.metrics.containerWidth / this.metrics.em;
            width = Math.max(this.length2em(w, cwidth) + (this.frame ? .14 : 0), width);
        }
        var _b = __read(this.getBBoxHD(height), 2), h = _b[0], d = _b[1];
        bbox.h = h;
        bbox.d = d;
        bbox.w = width;
    };
    CHTMLmtable.prototype.getBBoxHD = function (height) {
        var _a = __read(this.getAlignmentRow(), 2), align = _a[0], row = _a[1];
        if (row === null) {
            var a = this.font.params.axis_height;
            var h2 = height / 2;
            return {
                top: [0, height],
                center: [h2, h2],
                bottom: [height, 0],
                baseline: [h2, h2],
                axis: [h2 + a, h2 - a]
            }[align] || [h2, h2];
        }
        else {
            var y = this.getVerticalPosition(row, align);
            return [y, height - y];
        }
    };
    CHTMLmtable.prototype.padRows = function () {
        try {
            for (var _a = __values(this.adaptor.childNodes(this.adaptor.firstChild(this.chtml))), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                while (this.adaptor.childNodes(row).length < this.numCols) {
                    this.adaptor.append(row, this.html('mjx-mtd'));
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_5) throw e_5.error; }
        }
        var e_5, _c;
    };
    CHTMLmtable.prototype.handleColumnSpacing = function () {
        var fspace = this.em(this.fSpace[0]);
        var spacing = this.addEm(this.cSpace, 2);
        if (!spacing)
            return;
        spacing.unshift(fspace);
        spacing[this.numCols] = fspace;
        var frame = this.frame;
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var i = 0;
                var children = (row.firstCell ? row.childNodes.slice(row.firstCell) : row.childNodes);
                try {
                    for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
                        var cell = children_1_1.value;
                        var lspace = spacing[i++];
                        var rspace = spacing[i];
                        var styleNode = (cell ? cell.chtml : this.adaptor.childNodes(row.chtml)[i]);
                        if ((i > 1 && lspace !== '0.4em') || (frame && i === 1)) {
                            this.adaptor.setStyle(styleNode, 'paddingLeft', lspace);
                        }
                        if ((i < this.numCols && rspace !== '0.4em') || (frame && i === this.numCols)) {
                            this.adaptor.setStyle(styleNode, 'paddingRight', rspace);
                        }
                    }
                }
                catch (e_6_1) { e_6 = { error: e_6_1 }; }
                finally {
                    try {
                        if (children_1_1 && !children_1_1.done && (_c = children_1.return)) _c.call(children_1);
                    }
                    finally { if (e_6) throw e_6.error; }
                }
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
            }
            finally { if (e_7) throw e_7.error; }
        }
        var e_7, _d, e_6, _c;
    };
    CHTMLmtable.prototype.handleColumnLines = function () {
        if (this.node.attributes.get('columnlines') === 'none')
            return;
        var lines = this.getColumnAttributes('columnlines');
        if (!lines)
            return;
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var i = 0;
                try {
                    for (var _c = __values(this.adaptor.childNodes(row.chtml).slice(1)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        var line = lines[i++];
                        if (line === 'none')
                            continue;
                        this.adaptor.setStyle(cell, 'borderLeft', '.07em ' + line);
                    }
                }
                catch (e_8_1) { e_8 = { error: e_8_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_8) throw e_8.error; }
                }
            }
        }
        catch (e_9_1) { e_9 = { error: e_9_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_9) throw e_9.error; }
        }
        var e_9, _f, e_8, _e;
    };
    CHTMLmtable.prototype.handleColumnWidths = function () {
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var i = 0;
                try {
                    for (var _c = __values(this.adaptor.childNodes(row.chtml)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        var w = this.cWidths[i++];
                        if (w !== null) {
                            var width = (typeof w === 'number' ? this.em(w) : w);
                            this.adaptor.setStyle(cell, 'width', width);
                            this.adaptor.setStyle(cell, 'maxWidth', width);
                            this.adaptor.setStyle(cell, 'minWidth', width);
                        }
                    }
                }
                catch (e_10_1) { e_10 = { error: e_10_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_10) throw e_10.error; }
                }
            }
        }
        catch (e_11_1) { e_11 = { error: e_11_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_11) throw e_11.error; }
        }
        var e_11, _f, e_10, _e;
    };
    CHTMLmtable.prototype.handleRowSpacing = function () {
        var fspacing = this.em(this.fSpace[1]);
        var spacing = this.addEm(this.rSpace, 2);
        if (!spacing)
            return;
        spacing.unshift(fspacing);
        spacing[this.numRows] = fspacing;
        var frame = this.frame;
        var i = 0;
        try {
            for (var _a = __values(this.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var tspace = spacing[i++];
                var bspace = spacing[i];
                try {
                    for (var _c = __values(row.childNodes), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        if ((i > 1 && tspace !== '0.215em') || (frame && i === 1)) {
                            this.adaptor.setStyle(cell.chtml, 'paddingTop', tspace);
                        }
                        if ((i < this.numRows && bspace !== '0.215em') || (frame && i === this.numRows)) {
                            this.adaptor.setStyle(cell.chtml, 'paddingBottom', bspace);
                        }
                    }
                }
                catch (e_12_1) { e_12 = { error: e_12_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_12) throw e_12.error; }
                }
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_13) throw e_13.error; }
        }
        var e_13, _f, e_12, _e;
    };
    CHTMLmtable.prototype.handleRowLines = function () {
        if (this.node.attributes.get('rowlines') === 'none')
            return;
        var lines = this.getRowAttributes('rowlines');
        if (!lines)
            return;
        var i = 0;
        try {
            for (var _a = __values(this.childNodes.slice(1)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var row = _b.value;
                var line = lines[i++];
                if (line === 'none')
                    continue;
                try {
                    for (var _c = __values(this.adaptor.childNodes(row.chtml)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var cell = _d.value;
                        this.adaptor.setStyle(cell, 'borderTop', '.07em ' + line);
                    }
                }
                catch (e_14_1) { e_14 = { error: e_14_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                    }
                    finally { if (e_14) throw e_14.error; }
                }
            }
        }
        catch (e_15_1) { e_15 = { error: e_15_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
            }
            finally { if (e_15) throw e_15.error; }
        }
        var e_15, _f, e_14, _e;
    };
    CHTMLmtable.prototype.handleEqualRows = function () {
        if (!this.node.attributes.get('equalrows'))
            return;
        var space = this.rSpace.map(function (x) { return x / 2; });
        space.unshift(this.fSpace[1]);
        space.push(this.fSpace[1]);
        var _a = this.getTableData(), H = _a.H, D = _a.D;
        var HD = this.getEqualRowHeight();
        var HDem = this.em(HD);
        for (var i = 0; i < this.numRows; i++) {
            var row = this.childNodes[i];
            if (HD !== H[i] + D[i]) {
                this.setRowHeight(row, HD, (HD - H[i] + D[i]) / 2, space[i] + space[i + 1]);
            }
        }
    };
    CHTMLmtable.prototype.setRowHeight = function (row, HD, D, space) {
        var adaptor = this.adaptor;
        adaptor.setStyle(row.chtml, 'height', this.em(HD + space));
        var ralign = row.node.attributes.get('rowalign');
        try {
            for (var _a = __values(row.childNodes), _b = _a.next(); !_b.done; _b = _a.next()) {
                var cell = _b.value;
                var calign = cell.node.attributes.get('rowalign');
                if (calign === 'baseline' || calign === 'axis') {
                    var child = adaptor.lastChild(cell.chtml);
                    adaptor.setStyle(child, 'height', this.em(HD));
                    adaptor.setStyle(child, 'verticalAlign', this.em(-D));
                    if ((row.kind !== 'mlabeledtr' || cell !== row.childNodes[0]) &&
                        (ralign === 'baseline' || ralign === 'axis'))
                        break;
                }
            }
        }
        catch (e_16_1) { e_16 = { error: e_16_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_16) throw e_16.error; }
        }
        var e_16, _c;
    };
    CHTMLmtable.prototype.handleFrame = function () {
        if (this.frame) {
            this.adaptor.setStyle(this.adaptor.firstChild(this.chtml), 'border', '.07em ' + this.node.attributes.get('frame'));
        }
    };
    CHTMLmtable.prototype.handleWidth = function () {
        var w = this.node.attributes.get('width');
        var hasLabels = (this.adaptor.childNodes(this.labels).length > 0);
        if (isPercent(w) || hasLabels) {
            this.bbox.pwidth = (hasLabels ? '100%' : w);
            this.adaptor.setStyle(this.chtml, 'width', '100%');
        }
        else {
            if (w === 'auto')
                return;
            w = this.em(this.length2em(w) + (this.frame ? .14 : 0));
        }
        var table = this.adaptor.firstChild(this.chtml);
        this.adaptor.setStyle(table, 'minWidth', w);
    };
    CHTMLmtable.prototype.handleAlign = function () {
        var _a = __read(this.getAlignmentRow(), 2), align = _a[0], row = _a[1];
        if (row === null) {
            if (align !== 'axis') {
                this.adaptor.setAttribute(this.chtml, 'align', align);
            }
        }
        else {
            var y = this.getVerticalPosition(row, align);
            this.adaptor.setAttribute(this.chtml, 'align', 'top');
            this.adaptor.setStyle(this.chtml, 'verticalAlign', this.em(y));
        }
    };
    CHTMLmtable.prototype.handleLabels = function () {
        var labels = this.labels;
        var adaptor = this.adaptor;
        if (adaptor.childNodes(labels).length === 0)
            return;
        var side = this.node.attributes.get('side');
        adaptor.setAttribute(labels, 'side', side);
        adaptor.setStyle(labels, side, '0');
        var L = this.getTableData().L;
        var sep = this.length2em(this.node.attributes.get('minlabelspacing'));
        var table = adaptor.firstChild(this.chtml);
        adaptor.setStyle(table, 'margin', '0 ' + this.em(L + sep));
        this.updateRowHeights();
        this.addLabelSpacing();
        adaptor.append(this.chtml, labels);
    };
    CHTMLmtable.prototype.updateRowHeights = function () {
        if (this.node.attributes.get('equalrows'))
            return;
        var _a = this.getTableData(), H = _a.H, D = _a.D, NH = _a.NH, ND = _a.ND;
        var space = this.rSpace.map(function (x) { return x / 2; });
        space.unshift(this.fSpace[1]);
        space.push(this.fSpace[1]);
        for (var i = 0; i < this.numRows; i++) {
            if (H[i] !== NH[i] || D[i] !== ND[i]) {
                this.setRowHeight(this.childNodes[i], H[i] + D[i], D[i], space[i] + space[i + 1]);
            }
        }
    };
    CHTMLmtable.prototype.addLabelSpacing = function () {
        var adaptor = this.adaptor;
        var equal = this.node.attributes.get('equalrows');
        var _a = this.getTableData(), H = _a.H, D = _a.D;
        var HD = (equal ? this.getEqualRowHeight() : 0);
        var space = this.rSpace.map(function (x) { return x / 2; });
        space.unshift(this.fSpace[1]);
        space.push(this.fSpace[1]);
        var h = (this.frame ? .07 : 0);
        var current = adaptor.firstChild(this.labels);
        for (var i = 0; i < this.numRows; i++) {
            var row = this.childNodes[i];
            if (row.kind === 'mlabeledtr') {
                if (h) {
                    adaptor.insert(this.html('mjx-mtr', { style: { height: this.em(h) } }), current);
                    adaptor.setStyle(current, 'height', this.em((equal ? HD : H[i] + D[i]) + space[i] + space[i + 1]));
                    current = adaptor.next(current);
                    h = 0;
                }
            }
            else {
                h += space[i] + (equal ? HD : H[i] + D[i]) + space[i + 1] + this.rLines[i];
            }
        }
    };
    CHTMLmtable.prototype.getEqualRowHeight = function () {
        var _a = this.getTableData(), H = _a.H, D = _a.D;
        var HD = Array.from(H.keys()).map(function (i) { return H[i] + D[i]; });
        return Math.max.apply(Math, HD);
    };
    CHTMLmtable.prototype.getColumnWidths = function () {
        var width = this.node.attributes.get('width');
        if (this.node.attributes.get('equalcolumns')) {
            return this.getEqualColumns(width);
        }
        var swidths = this.getColumnAttributes('columnwidth', 0);
        if (width === 'auto') {
            return this.getColumnWidthsAuto(swidths);
        }
        if (isPercent(width)) {
            return this.getColumnWidthsPercent(swidths, width);
        }
        return this.getColumnWidthsFixed(swidths, this.length2em(width));
    };
    CHTMLmtable.prototype.getEqualColumns = function (width) {
        var n = Math.max(1, this.numCols);
        var cwidth;
        if (width === 'auto') {
            var W = this.getTableData().W;
            cwidth = MAX(W);
        }
        else if (isPercent(width)) {
            cwidth = this.percent(1 / n);
        }
        else {
            var w = SUM([].concat(this.cLines, this.cSpace)) + 2 * this.fSpace[0];
            cwidth = Math.max(0, this.length2em(width) - w) / n;
        }
        return Array(this.numCols).fill(cwidth);
    };
    CHTMLmtable.prototype.getColumnWidthsAuto = function (swidths) {
        var _this = this;
        return swidths.map(function (x) {
            if (x === 'auto' || x === 'fit')
                return null;
            if (isPercent(x))
                return x;
            return _this.length2em(x);
        });
    };
    CHTMLmtable.prototype.getColumnWidthsPercent = function (swidths, width) {
        var _this = this;
        var hasFit = swidths.indexOf('fit') >= 0;
        var W = (hasFit ? this.getTableData() : { W: null }).W;
        return Array.from(swidths.keys()).map(function (i) {
            var x = swidths[i];
            if (x === 'fit')
                return null;
            if (x === 'auto')
                return (hasFit ? W[i] : null);
            if (isPercent(x))
                return x;
            return _this.length2em(x);
        });
    };
    CHTMLmtable.prototype.getColumnWidthsFixed = function (swidths, width) {
        var _this = this;
        var indices = Array.from(swidths.keys());
        var fit = indices.filter(function (i) { return swidths[i] === 'fit'; });
        var auto = indices.filter(function (i) { return swidths[i] === 'auto'; });
        var n = fit.length || auto.length;
        var W = (n ? this.getTableData() : { W: null }).W;
        var cwidth = width - SUM([].concat(this.cLines, this.cSpace)) - 2 * this.fSpace[0];
        var dw = cwidth;
        indices.forEach(function (i) {
            var x = swidths[i];
            dw -= (x === 'fit' || x === 'auto' ? W[i] : _this.length2em(x, width));
        });
        var fw = (n && dw > 0 ? dw / n : 0);
        return indices.map(function (i) {
            var x = swidths[i];
            if (x === 'fit')
                return W[i] + fw;
            if (x === 'auto')
                return W[i] + (fit.length === 0 ? fw : 0);
            return _this.length2em(x, cwidth);
        });
    };
    CHTMLmtable.prototype.getVerticalPosition = function (i, align) {
        var equal = this.node.attributes.get('equalrows');
        var _a = this.getTableData(), H = _a.H, D = _a.D;
        var HD = (equal ? this.getEqualRowHeight() : 0);
        var space = this.rSpace.map(function (x) { return x / 2; });
        space.unshift(this.fSpace[1]);
        space.push(this.fSpace[1]);
        var y = (this.frame ? .07 : 0);
        for (var j = 0; j < i; j++) {
            y += space[j] + (equal ? HD : H[j] + D[j]) + space[j + 1] + this.rLines[j];
        }
        var _b = __read((equal ? [(HD + H[i] - D[i]) / 2, (HD - H[i] + D[i]) / 2] : [H[i], D[i]]), 2), h = _b[0], d = _b[1];
        y += {
            top: 0,
            center: space[i] + (h + d) / 2,
            bottom: space[i] + h + d + space[i + 1],
            baseline: space[i] + h,
            axis: space[i] + h - .25
        }[align] || 0;
        return y;
    };
    CHTMLmtable.prototype.getAlignmentRow = function () {
        var _a = __read(SPLIT(this.node.attributes.get('align')), 2), align = _a[0], row = _a[1];
        if (row == null)
            return [align, null];
        var i = parseInt(row);
        if (i < 0)
            i += this.numRows;
        return [align, i < 1 || i > this.numRows ? null : i - 1];
    };
    CHTMLmtable.prototype.getColumnAttributes = function (name, i) {
        if (i === void 0) { i = 1; }
        var n = this.numCols - i;
        var columns = this.getAttributeArray(name);
        if (columns.length === 0)
            return;
        while (columns.length < n) {
            columns.push(columns[columns.length - 1]);
        }
        if (columns.length > n) {
            columns.splice(n);
        }
        return columns;
    };
    CHTMLmtable.prototype.getRowAttributes = function (name, i) {
        if (i === void 0) { i = 1; }
        var n = this.numRows - i;
        var rows = this.getAttributeArray(name);
        if (rows.length === 0)
            return;
        while (rows.length < n) {
            rows.push(rows[rows.length - 1]);
        }
        if (rows.length > n) {
            rows.splice(n);
        }
        return rows;
    };
    CHTMLmtable.prototype.getAttributeArray = function (name) {
        var value = this.node.attributes.get(name);
        if (!value)
            return [];
        return SPLIT(value);
    };
    CHTMLmtable.prototype.addEm = function (list, n) {
        var _this = this;
        if (n === void 0) { n = 1; }
        if (!list)
            return;
        return list.map(function (x) { return _this.em(x / n); });
    };
    CHTMLmtable.prototype.convertLengths = function (list) {
        var _this = this;
        if (!list)
            return;
        return list.map(function (x) { return _this.length2em(x); });
    };
    return CHTMLmtable;
}(Wrapper_js_1.CHTMLWrapper));
CHTMLmtable.kind = mtable_js_1.MmlMtable.prototype.kind;
CHTMLmtable.styles = {
    'mjx-mtable': {
        'vertical-align': '.25em',
        'text-align': 'center',
        'position': 'relative'
    },
    'mjx-mtable > mjx-itable': {
        'vertical-align': 'middle',
        'text-align': 'left',
        'box-sizing': 'border-box'
    },
    'mjx-labels': {
        display: 'inline-table',
        position: 'absolute',
        top: 0
    },
    'mjx-mtable[align]': {
        'vertical-align': 'baseline'
    },
    'mjx-mtable[align="top"] > mjx-itable': {
        'vertical-align': 'top'
    },
    'mjx-mtable[align="bottom"] > mjx-itable': {
        'vertical-align': 'bottom'
    },
    'mjx-mtable[align="center"] > mjx-itable': {
        'vertical-align': 'middle'
    },
    'mjx-mtable[align="baseline"] > mjx-itable': {
        'vertical-align': 'middle'
    }
};
exports.CHTMLmtable = CHTMLmtable;
//# sourceMappingURL=mtable.js.map