import { CHTMLWrapper } from '../Wrapper.js';
import { CHTMLWrapperFactory } from '../WrapperFactory.js';
import { CHTMLmsubsup, CHTMLmsub, CHTMLmsup } from './msubsup.js';
import { MmlNode } from '../../../core/MmlTree/MmlNode.js';
import { BBox } from '../BBox.js';
import { StyleList } from '../CssStyles.js';
export declare class CHTMLmunder<N, T, D> extends CHTMLmsub<N, T, D> {
    static kind: string;
    static useIC: boolean;
    static styles: StyleList;
    readonly script: CHTMLWrapper<N, T, D>;
    constructor(factory: CHTMLWrapperFactory<N, T, D>, node: MmlNode, parent?: CHTMLWrapper<N, T, D>);
    toCHTML(parent: N): void;
    computeBBox(bbox: BBox): void;
}
export declare class CHTMLmover<N, T, D> extends CHTMLmsup<N, T, D> {
    static kind: string;
    static useIC: boolean;
    static styles: StyleList;
    readonly script: CHTMLWrapper<N, T, D>;
    constructor(factory: CHTMLWrapperFactory<N, T, D>, node: MmlNode, parent?: CHTMLWrapper<N, T, D>);
    toCHTML(parent: N): void;
    computeBBox(bbox: BBox): void;
}
export declare class CHTMLmunderover<N, T, D> extends CHTMLmsubsup<N, T, D> {
    static kind: string;
    static useIC: boolean;
    static styles: StyleList;
    readonly underChild: CHTMLWrapper<N, T, D>;
    readonly overChild: CHTMLWrapper<N, T, D>;
    readonly subChild: CHTMLWrapper<N, T, D>;
    readonly supChild: CHTMLWrapper<N, T, D>;
    constructor(factory: CHTMLWrapperFactory<N, T, D>, node: MmlNode, parent?: CHTMLWrapper<N, T, D>);
    toCHTML(parent: N): void;
    computeBBox(bbox: BBox): void;
}
